VERSION 5.00
Begin VB.Form frmLBSbCls 
   Caption         =   "Listbox Subclassing and Non-selectable Items"
   ClientHeight    =   5310
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6255
   LinkTopic       =   "Form1"
   ScaleHeight     =   5310
   ScaleWidth      =   6255
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   800
      Left            =   1320
      Top             =   5280
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Add 3 more items"
      Height          =   375
      Left            =   3000
      TabIndex        =   5
      Top             =   4320
      Width           =   3135
   End
   Begin VB.ListBox List1 
      BackColor       =   &H00C0FFC0&
      ForeColor       =   &H00C000C0&
      Height          =   3240
      IntegralHeight  =   0   'False
      Left            =   0
      Style           =   1  'Checkbox
      TabIndex        =   3
      Top             =   960
      Width           =   6255
   End
   Begin VB.CheckBox Check2 
      Caption         =   "Setup Listbox Messaged Hook ( Subclass List box)"
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   6255
   End
   Begin VB.CheckBox Check1 
      Height          =   375
      Left            =   0
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   480
      Width           =   6255
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Clear All  and ADD"
      Height          =   375
      Left            =   0
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   4320
      Width           =   2775
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   375
      Left            =   0
      TabIndex        =   4
      Top             =   4800
      Width           =   5415
   End
End
Attribute VB_Name = "frmLBSbCls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private m_hooked As Boolean
Private Sub Check1_Click()
    With Check1
    If .Value = 1 Then
         mLBSbCls.SetListBox List1
        ' set the hook procedure
        SetHookParent Me.hwnd, True
        m_hooked = True
        
        .Caption = "UnSet the Listbox Notification Hook ( from Form)"
    
    Else
        SetHookParent Me.hwnd, False
        m_hooked = False
        .Caption = "Subclass Parent form ( Gives Gray shading items)"
    End If
    End With

End Sub

Private Sub Check2_Click()
    If Check2.Value = 1 Then
        SetHookLB List1.hwnd, True
        Check2.Caption = " Unhook listbox : Remove subclass procedure"
    Else
        SetHookLB List1.hwnd, False
        Check2.Caption = " Hook (subclass) list box - Process && remove click on Gray items"
    End If
End Sub


Private Sub Command1_Click()
    Dim i
    List1.Clear
    For i = 0 To 10
        List1.AddItem "Item - " & Str(i)
    Next i
End Sub

Private Sub Command2_Click()
    Dim i As Integer
    For i = 0 To 2
        With List1
            .AddItem "Item - " & Str(.ListCount)
        End With
    Next i
End Sub

Private Sub Form_Activate()
    Debug.Print " Form Hwnd=" & Hex$(Me.hwnd);
    Debug.Print " List hwnd=" & Hex$(List1.hwnd);
    Debug.Print " Check1 hwnd=" & Hex$(Check1.hwnd);
    Debug.Print " Command1 hwnd=" & Hex$(Command1.hwnd)
    
    Dim lrtn As Long
    lrtn = GetWindowLong(List1.hwnd, GWL_STYLE)
    Debug.Print "List box Style:0x" & Hex$(lrtn)
    If (lrtn And LBS_OWNERDRAWFIXED) = LBS_OWNERDRAWFIXED Then
        Debug.Print "List box style: OwnerDraw Fixed"
    End If
    If (lrtn And LBS_MULTIPLESEL) = LBS_MULTIPLESEL Then
        Debug.Print "List box style: Multiple selection"
        lrtn = lrtn Xor LBS_MULTIPLESEL
    End If
    Debug.Print "Setting window style: 0x" & Hex$(lrtn)
    lrtn = SetWindowLong(List1.hwnd, GWL_STYLE, lrtn)
    Debug.Print "Setwindow rtn value : 0x" & Hex$(lrtn)
    
End Sub

Private Sub Form_Load()
    
    If App.PrevInstance = True Then
        MsgBox "There is an instance already running. Cant run one more"
        Unload Me
    Else
        Command1_Click
    End If
    ' These 2 lines give more GUI effect
    Check2.Value = 1
    Check1.Value = 1
    
    ' If you uncomment the following lines of code, then
    ' do the same in Form_Unload also
    'Staraight forward calling also works
    'mLBSbCls.SetListBox List1
    'mLBSbCls.SetLBParent Me
    'mLBSbCls.SetHooks
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call Timer1_Timer
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If Check2.Value = 1 Then
        SetHookLB List1.hwnd, False
    End If
    If m_hooked Then
        SetHookParent Me.hwnd, False
    End If
    'mLBSbCls.UnSetHooks
End Sub

Private Sub List1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call Timer1_Timer
End Sub

Private Sub Timer1_Timer()
    Label1.Caption = "List Index=" & Str(List1.ListIndex)
End Sub

